#if (!requireNamespace("BiocManager", quietly = TRUE))
#    install.packages("BiocManager")
#BiocManager::install("limma")


library(limma)
corFilter=0.35            
pvalueFilter=0.001      #

rt = read.table(file = "lncRNA.txt", header=T, sep="\t", check.names=F)
rt=as.matrix(rt)
rownames(rt)=rt[,1]
exp=rt[,2:ncol(rt)]
dimnames=list(rownames(exp),colnames(exp))
data=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
data=avereps(data)
data=data[rowMeans(data)>0.2,]
save(data, file = "lncRNA.Rdata") #һԺõ
load(file = "lncRNA.Rdata")
#ɾƷ
group=sapply(strsplit(colnames(data),"\\-"), "[", 4)
group=sapply(strsplit(group,""), "[", 1)
group=gsub("2","1",group)
lncRNA=data[,group==0]

#ȡļ,ݽд
rt = read.table("FerrGeneExp.txt", header=T, sep="\t", check.names=F)
rt=as.matrix(rt)
rownames(rt)=rt[,1]
exp=rt[,2:ncol(rt)]
dimnames=list(rownames(exp),colnames(exp))
ferrGene=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
ferrGene=avereps(ferrGene)
ferrGene=ferrGene[rowMeans(ferrGene)>0.2,]

#ɾƷ
group=sapply(strsplit(colnames(ferrGene),"\\-"), "[", 4)
group=sapply(strsplit(group,""), "[", 1)
group=gsub("2","1",group)
ferrGene=ferrGene[,group==0]

#Լ
outTab=data.frame()
for(i in row.names(lncRNA)){
  if(sd(lncRNA[i,])>0.2){
    for(j in row.names(ferrGene)){
      x=as.numeric(lncRNA[i,])
      y=as.numeric(ferrGene[j,])
      corT=cor.test(x,y)
      cor=corT$estimate
      pvalue=corT$p.value
      if((cor>corFilter) & (pvalue<pvalueFilter)){
        outTab=rbind(outTab,cbind(ferrGene=j,lncRNA=i,cor,pvalue,Regulation="postive"))
      }
      if((cor< -corFilter) & (pvalue<pvalueFilter)){
        outTab=rbind(outTab,cbind(ferrGene=j,lncRNA=i,cor,pvalue,Regulation="negative"))
      }
    }
  }
}

#Խ
write.table(outTab, file="corResult.txt",sep="\t",quote=F,row.names=F)

#lncRNAı
ferrLncRNA=unique(as.vector(outTab[,"lncRNA"]))
ferrLncRNAexp=data[ferrLncRNA,]
ferrLncRNAexp=rbind(ID=colnames(ferrLncRNAexp), ferrLncRNAexp)
write.table(ferrLncRNAexp,file="FerrLncExp.txt",sep="\t",quote=F,col.names=F)


rm(list= ls ())
