library(limma)                   
lncFile="lncRNA.diffExp.txt"      
cliFile="TCGA-KIRC.survival.tsv"                


rt=read.table(lncFile, header=T, sep="\t", check.names=F)
rt=as.matrix(rt)
rownames(rt)=rt[,1]
exp=rt[,2:ncol(rt)]
dimnames=list(rownames(exp), colnames(exp))
data=matrix(as.numeric(as.matrix(exp)), nrow=nrow(exp), dimnames=dimnames)
data=avereps(data)


group=sapply(strsplit(colnames(data),"\\-"),"[",4)
group=sapply(strsplit(group,""),"[",1)
group=gsub("2","1",group)
data=data[,group==0]
colnames(data)=gsub("(.*?)\\-(.*?)\\-(.*?)\\-(.*?)\\-.*", "\\1\\-\\2\\-\\3", colnames(data))
data=t(data)
data=avereps(data)

#survival data
cli=read.table("TCGA-KIRC.survival.tsv",sep="\t",check.names=F,header=T,row.names=1)
#install.packages("dplyr")
library(dplyr)
cli <- cli %>% distinct(`_PATIENT`, .keep_all = T)
rownames(cli) = cli$`_PATIENT`
cli=cli[,c(1,3)]
colnames(cli) = c("fustat", "futime")

sameSample=intersect(row.names(data),row.names(cli))
data=data[sameSample,]
cli=cli[sameSample,]
out=cbind(cli,data)

out=cbind(id=row.names(out),out)
write.table(out,file="expTime.txt",sep="\t",row.names=F,quote=F)

rm(list=ls())

